diff --git a/src/modules/Extensions/YouTube.cpp b/src/modules/Extensions/YouTube.cpp
index 4d7b794f..d168f9bb 100644
--- a/src/modules/Extensions/YouTube.cpp
+++ b/src/modules/Extensions/YouTube.cpp
@@ -938,11 +1028,11 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
         if (format.isEmpty())
             continue;
 
-        const auto container = format["container"].toString();
-        if (container.contains("dash", Qt::CaseInsensitive))
+        const auto protocol = format["protocol"].toString();
+        if (protocol.contains("dash", Qt::CaseInsensitive))
         {
-            // Skip MP4 DASH, because it doesn't work properly
-            continue;
+            if (format.contains("fragment_base_url"))
+                continue; // Skip DASH, because it doesn't work
         }
 
         const auto itag = format["format_id"].toString().toInt();
@@ -952,11 +1042,11 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
             itagsData[itag] = {url, "." + ext};
     }
 
-    auto appendUrl = [&](const QList<int> &itags) {
+    auto appendUrl = [&](const QVector<int> &itags) {
         for (auto &&itag : itags)
         {
             auto it = itagsData.constFind(itag);
-            if (it != itagsData.cend())
+            if (it != itagsData.constEnd())
             {
                 urls += it->first;
                 exts += it->second;
@@ -965,19 +1055,21 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
         }
     };
 
-    if (!isLive)
+    if (isLive)
     {
+        appendUrl(hlsItags);
+    }
+    else
+    {
+        appendUrl(audioItags);
         if (!audioOnly)
             appendUrl(videoItags);
-        appendUrl(audioItags);
     }
+
     if (urls.count() != 1 + (audioOnly ? 0 : 1))
     {
-        if (!urls.isEmpty())
-            urls.clear();
-        appendUrl(hlsItags);
-        if (urls.isEmpty())
-            appendUrl(singleUrlItags);
+        urls.clear();
+        exts.clear();
     }
 
     if (urls.isEmpty())
@@ -988,6 +1080,8 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
 
     const auto subtitles = o["subtitles"].toObject();
     QString lang = QMPlay2Core.getSettings().getString("SubtitlesLanguage");
+    if (lang.isEmpty()) // Default language
+        lang = QLocale::languageToString(QLocale::system().language());
     if (!audioOnly && m_allowSubtitles && !subtitles.isEmpty() && !lang.isEmpty())
     {
         // Try to convert full language name into short language code
@@ -1007,6 +1101,8 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
         auto subtitlesForLang = subtitles[lang].toArray();
         if (subtitlesForLang.isEmpty())
             subtitlesForLang = subtitles[QMPlay2Core.getLanguage()].toArray();
+        if (subtitlesForLang.isEmpty())
+            subtitlesForLang = subtitles["en"].toArray();
 
         for (auto &&subtitlesFmtVal : asConst(subtitlesForLang))
         {
@@ -1056,44 +1152,78 @@ QStringList YouTube::getYouTubeVideo(const QString &param, const QString &url, I
     return result;
 }
 
-void YouTube::preparePlaylist(const QString &data, QTreeWidgetItem *tWI)
+void YouTube::preparePlaylist(const QByteArray &data, QTreeWidgetItem *tWI)
 {
-    int idx = data.indexOf("playlist-videos-container");
-    if (idx > -1)
+    QStringList playlist;
+
+    const auto json = getYtInitialData(data);
+
+    const auto contents = json.object()
+        ["contents"].toObject()
+        ["twoColumnBrowseResultsRenderer"].toObject()
+        ["tabs"].toArray().at(0).toObject()
+        ["tabRenderer"].toObject()
+        ["content"].toObject()
+        ["sectionListRenderer"].toObject()
+        ["contents"].toArray().at(0).toObject()
+        ["itemSectionRenderer"].toObject()
+        ["contents"].toArray().at(0).toObject()
+        ["playlistVideoListRenderer"].toObject()
+        ["contents"].toArray()
+    ;
+
+    for (auto &&obj : contents)
     {
-        const QString tags[2] = {"video-id", "video-title"};
-        QStringList playlist, entries = data.mid(idx).split("yt-uix-scroller-scroll-unit", QString::SkipEmptyParts);
-        entries.removeFirst();
-        for (const QString &entry : asConst(entries))
-        {
-            QStringList plistEntry;
-            for (int i = 0; i < 2; ++i)
-            {
-                idx = entry.indexOf(tags[i]);
-                if (idx > -1 && (idx = entry.indexOf('"', idx += tags[i].length())) > -1)
-                {
-                    const int endIdx = entry.indexOf('"', idx += 1);
-                    if (endIdx > -1)
-                    {
-                        const QString str = entry.mid(idx, endIdx - idx);
-                        if (!i)
-                            plistEntry += str;
-                        else
-                        {
-                            QTextDocument txtDoc;
-                            txtDoc.setHtml(str);
-                            plistEntry += txtDoc.toPlainText();
-                        }
-                    }
-                }
-            }
-            if (plistEntry.count() == 2)
-                playlist += plistEntry;
-        }
-        if (!playlist.isEmpty())
-        {
-            tWI->setData(0, Qt::UserRole + 1, playlist);
-            tWI->setDisabled(false);
-        }
+        const auto playlistRenderer = obj.toObject()["playlistVideoRenderer"].toObject();
+
+        const auto title = playlistRenderer["title"].toObject()["runs"].toArray().at(0).toObject()["text"].toString();
+        const auto videoId = playlistRenderer["videoId"].toString();
+        if (title.isEmpty() || videoId.isEmpty())
+            continue;
+
+        playlist += {
+            videoId,
+            title,
+        };
+    }
+
+    if (!playlist.isEmpty())
+    {
+        tWI->setData(0, Qt::UserRole + 1, playlist);
+        tWI->setDisabled(false);
+    }
+}
+
+void YouTube::onShowSettingsClicked() {
+    emit QMPlay2Core.showSettings("Extensions");
+}
+
+void YouTube::onSortByChanged(int index) {
+    if (m_sortByIdx != index) {
+        m_sortByIdx = index;
+        sets().set("YouTube/SortBy", m_sortByIdx);
+        search();
     }
 }
+
+QJsonDocument YouTube::getYtInitialData(const QByteArray &data)
+{
+    int idx = data.indexOf("ytInitialData");
+    if (idx < 0)
+        return QJsonDocument();
+
+    idx = data.indexOf("{", idx);
+    if (idx < 0)
+        return QJsonDocument();
+
+    QJsonParseError e = {};
+    auto jsonDoc = QJsonDocument::fromJson(data.mid(idx), &e);
+
+    if (Q_UNLIKELY(e.error == QJsonParseError::NoError))
+        return jsonDoc;
+
+    if (e.error == QJsonParseError::GarbageAtEnd && e.offset > 0)
+        return QJsonDocument::fromJson(data.mid(idx, e.offset));
+
+    return QJsonDocument();
+}
diff --git a/src/modules/Extensions/YouTube.hpp b/src/modules/Extensions/YouTube.hpp
index 17350c2d..d853bbb1 100644
--- a/src/modules/Extensions/YouTube.hpp
+++ b/src/modules/Extensions/YouTube.hpp
@@ -26,6 +26,8 @@
 #include <QPointer>
 #include <QMutex>
 
+#include <QJsonDocument.h>
+
 class NetworkReply;
 class QProgressBar;
 class QActionGroup;
@@ -37,18 +39,27 @@ class LineEdit;
 class QLabel;
 class QMenu;
 
+enum class PreferredCodec
+{
+    VP9,
+    H264,
+    AV1,
+};
+
 /**/
 
-class ResultsYoutube final : public QTreeWidget
+class ResultsYoutube : public QTreeWidget
 {
     Q_OBJECT
 public:
     ResultsYoutube();
-    ~ResultsYoutube();
+    ~ResultsYoutube() final;
 
 private:
     void playOrEnqueue(const QString &param, QTreeWidgetItem *tWI, const QString &addrParam = QString());
 
+    QString currentParam;
+
     QMenu *menu;
 
 private slots:
@@ -58,11 +69,14 @@ private slots:
     void copyPageURL();
 
     void contextMenu(const QPoint &p);
+
+    void playCurrentItem();
+    void enqueueCurrentItem();
 };
 
 /**/
 
-class PageSwitcher final : public QWidget
+class PageSwitcher : public QWidget
 {
     Q_OBJECT
 public:
@@ -76,7 +90,7 @@ public:
 
 using ItagNames = QPair<QStringList, QList<int>>;
 
-class YouTube final : public QWidget, public QMPlay2Extensions
+class YouTube : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -85,19 +99,19 @@ public:
 
 public:
     YouTube(Module &module);
-    ~YouTube();
+    ~YouTube() final;
 
-    bool set() override;
+    bool set() override final;
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget() override final;
 
-    bool canConvertAddress() const override;
+    bool canConvertAddress() const override final;
 
-    QString matchAddress(const QString &url) const override;
-    QList<AddressPrefix> addressPrefixList(bool) const override;
-    void convertAddress(const QString &, const QString &, const QString &, QString *, QString *, QIcon *, QString *, IOController<> *ioCtrl) override;
+    QString matchAddress(const QString &url) const override final;
+    QList<AddressPrefix> addressPrefixList(bool) const override final;
+    void convertAddress(const QString &, const QString &, const QString &, QString *, QString *, QIcon *, QString *, IOController<> *ioCtrl) override final;
 
-    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override;
+    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override final;
 
 private slots:
     void next();
@@ -111,18 +125,26 @@ private slots:
 
     void searchMenu();
 
+    void onShowSettingsClicked();
+    void onQualityPresetChanged(const QString &preset);
+    void onQualityToggled();
+    void onSortByChanged(int index);
+
 private:
     void setItags(int qualityIdx);
 
     void deleteReplies();
 
     void setAutocomplete(const QByteArray &data);
-    void setSearchResults(QString data);
+    void setSearchResults(const QByteArray &data);
 
     QStringList getYouTubeVideo(const QString &param, const QString &url, IOController<YouTubeDL> &youTubeDL);
 
-    void preparePlaylist(const QString &data, QTreeWidgetItem *tWI);
+    void preparePlaylist(const QByteArray &data, QTreeWidgetItem *tWI);
 
+    QJsonDocument getYtInitialData(const QByteArray &data);
+
+private:
     DockWidget *dw;
 
     QIcon youtubeIcon, videoIcon;
@@ -148,7 +170,9 @@ private:
     int m_sortByIdx = 0;
 
     QMutex m_itagsMutex;
-    QList<int> m_videoItags, m_audioItags, m_hlsItags, m_singleUrlItags;
+    PreferredCodec m_preferredCodec = PreferredCodec::VP9;
+    bool m_allowVp9Hdr = false;
+    QVector<int> m_videoItags, m_audioItags, m_hlsItags, m_singleUrlItags;
 };
 
 #define YouTubeName "YouTube Browser"
diff --git a/src/modules/FFmpeg/FFDemux.cpp b/src/modules/FFmpeg/FFDemux.cpp
index f8fa33ee..69c5942f 100644
--- a/src/modules/FFmpeg/FFDemux.cpp
+++ b/src/modules/FFmpeg/FFDemux.cpp
@@ -408,15 +408,18 @@ Playlist::Entries FFDemux::fetchTracks(const QString &url, bool &ok)
             {
                 Playlist::Entry &entry = entries[i];
                 const bool lastItem = (i == entries.count() - 1);
-                const double start = indexes.value(i).second;
-                const double end = indexes.value(i + 1, {-1.0, -1.0}).first;
+                const double start = indexes.contains(i) ? indexes.value(i).second : -1.0;
+                double end = -1.0;
+                if (indexes.contains(i + 1))
+                    end = indexes.value(i + 1).first;
+
                 if (entry.url.isEmpty() || start < 0.0 || (end <= 0.0 && !lastItem))
                 {
-                    entries.removeAt(i);
+                    entries.remove(i);
                     continue;
                 }
                 const QString param = QString("CUE:%1:%2").arg(start).arg(end);
-                if (lastItem && end < 0.0) // Last entry doesn't have specified length in CUE file
+                if (lastItem && end < 0.0)
                 {
                     FormatContext *fmtCtx = createFmtCtx();
                     if (fmtCtx->open(entry.url, param))
diff --git a/src/modules/FFmpeg/FFDemux.hpp b/src/modules/FFmpeg/FFDemux.hpp
index 498f4b29..389b3419 100644
--- a/src/modules/FFmpeg/FFDemux.hpp
+++ b/src/modules/FFmpeg/FFDemux.hpp
@@ -22,42 +22,42 @@
 
 class FormatContext;
 
-class FFDemux final : public Demuxer
+class FFDemux : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(FFDemux)
 public:
     FFDemux(Module &);
 private:
-    ~FFDemux();
+    ~FFDemux() final;
 
-    bool set() override;
+    bool set() override final;
 
-    bool metadataChanged() const override;
+    bool metadataChanged() const override final;
 
-    bool isStillImage() const override;
+    bool isStillImage() const override final;
 
-    QList<ProgramInfo> getPrograms() const override;
-    QList<ChapterInfo> getChapters() const override;
+    QList<ProgramInfo> getPrograms() const override final;
+    QList<ChapterInfo> getChapters() const override final;
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    bool getReplayGain(bool album, float &gain_db, float &peak) const override;
-    qint64 size() const override;
-    double length() const override;
-    int bitrate() const override;
-    QByteArray image(bool forceCopy) const override;
+    QString name() const override final;
+    QString title() const override final;
+    QList<QMPlay2Tag> tags() const override final;
+    bool getReplayGain(bool album, float &gain_db, float &peak) const override final;
+    qint64 size() const override final;
+    double length() const override final;
+    int bitrate() const override final;
+    QByteArray image(bool forceCopy) const override final;
 
-    bool localStream() const override;
+    bool localStream() const override final;
 
-    bool seek(double pos, bool backward) override;
-    bool read(Packet &encoded, int &idx) override;
-    void pause() override;
-    void abort() override;
+    bool seek(double pos, bool backward) override final;
+    bool read(Packet &encoded, int &idx) override final;
+    void pause() override final;
+    void abort() override final;
 
-    bool open(const QString &entireUrl) override;
+    bool open(const QString &entireUrl) override final;
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok) override final;
 
     /**/
 
diff --git a/src/modules/FFmpeg/FFReader.hpp b/src/modules/FFmpeg/FFReader.hpp
index 75caec11..0cd53f11 100644
--- a/src/modules/FFmpeg/FFReader.hpp
+++ b/src/modules/FFmpeg/FFReader.hpp
@@ -24,25 +24,25 @@
 
 struct AVIOContext;
 
-class FFReader final : public Reader
+class FFReader : public Reader
 {
 public:
     FFReader();
 private:
-    bool readyRead() const override;
-    bool canSeek() const override;
+    bool readyRead() const override final;
+    bool canSeek() const override final;
 
-    bool seek(qint64) override;
-    QByteArray read(qint64) override;
-    void pause() override;
-    bool atEnd() const override;
-    void abort() override;
+    bool seek(qint64) override final;
+    QByteArray read(qint64) override final;
+    void pause() override final;
+    bool atEnd() const override final;
+    void abort() override final;
 
-    qint64 size() const override;
-    qint64 pos() const override;
-    QString name() const override;
+    qint64 size() const override final;
+    qint64 pos() const override final;
+    QString name() const override final;
 
-    bool open() override;
+    bool open() override final;
 
     /**/
 
diff --git a/src/modules/FFmpeg/FFmpeg.hpp b/src/modules/FFmpeg/FFmpeg.hpp
index 70e73d4e..0e5ad238 100644
--- a/src/modules/FFmpeg/FFmpeg.hpp
+++ b/src/modules/FFmpeg/FFmpeg.hpp
@@ -24,19 +24,19 @@
 
 class QComboBox;
 
-class FFmpeg final : public Module
+class FFmpeg : public Module
 {
     Q_DECLARE_TR_FUNCTIONS(FFmpeg)
 public:
     FFmpeg();
-    ~FFmpeg();
+    ~FFmpeg() final;
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 
-    void videoDeintSave() override;
+    void videoDeintSave() override final;
 
     /**/
 
@@ -65,7 +65,7 @@ class QGroupBox;
 class QSpinBox;
 class Slider;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
 #ifdef QMPlay2_VDPAU
     Q_OBJECT
@@ -84,7 +84,7 @@ private slots:
     void checkEnables();
 #endif
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     QGroupBox *demuxerB;
     QCheckBox *reconnectStreamedB;
diff --git a/src/modules/FFmpeg/FormatContext.cpp b/src/modules/FFmpeg/FormatContext.cpp
index 0dd0231f..71b2a266 100644
--- a/src/modules/FFmpeg/FormatContext.cpp
+++ b/src/modules/FFmpeg/FormatContext.cpp
@@ -843,6 +843,10 @@ StreamInfo *FormatContext::getStreamInfo(AVStream *stream) const
         if (streamInfo->codec_name.isEmpty())
             streamInfo->codec_name = codecDescr->name;
     }
+    else if (stream->codecpar->codec_type == AVMEDIA_TYPE_SUBTITLE)
+    {
+        streamInfo->must_decode = false;
+    }
 
     streamInfo->bitrate = stream->codecpar->bit_rate;
     streamInfo->bpcs = stream->codecpar->bits_per_coded_sample;
diff --git a/src/modules/FFmpeg/VAAPIWriter.hpp b/src/modules/FFmpeg/VAAPIWriter.hpp
index c36966db..84249e53 100644
--- a/src/modules/FFmpeg/VAAPIWriter.hpp
+++ b/src/modules/FFmpeg/VAAPIWriter.hpp
@@ -24,27 +24,27 @@
 #include <QWidget>
 #include <QTimer>
 
-class VAAPIWriter final : public QWidget, public VideoWriter
+class VAAPIWriter : public QWidget, public VideoWriter
 {
     Q_OBJECT
 public:
     VAAPIWriter(Module &module, VAAPI *vaapi);
-    ~VAAPIWriter();
+    ~VAAPIWriter() final;
 
-    bool set() override;
+    bool set() override final;
 
-    bool readyWrite() const override;
+    bool readyWrite() const override final;
 
-    bool processParams(bool *paramsCorrected) override;
-    void writeVideo(const VideoFrame &videoFrame) override;
-    void writeOSD(const QList<const QMPlay2OSD *> &osd) override;
-    void pause() override;
+    bool processParams(bool *paramsCorrected) override final;
+    void writeVideo(const VideoFrame &videoFrame) override final;
+    void writeOSD(const QList<const QMPlay2OSD *> &osd) override final;
+    void pause() override final;
 
-    bool hwAccelGetImg(const VideoFrame &videoFrame, void *dest, ImgScaler *nv12ToRGB32) const override;
+    bool hwAccelGetImg(const VideoFrame &videoFrame, void *dest, ImgScaler *nv12ToRGB32) const override final;
 
-    QString name() const override;
+    QString name() const override final;
 
-    bool open() override;
+    bool open() override final;
 
     /**/
 
@@ -56,11 +56,11 @@ public:
 private:
     void draw(VASurfaceID id = -1, int field = -1);
 
-    void resizeEvent(QResizeEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void resizeEvent(QResizeEvent *) override final;
+    void paintEvent(QPaintEvent *) override final;
+    bool event(QEvent *) override final;
 
-    QPaintEngine *paintEngine() const override;
+    QPaintEngine *paintEngine() const override final;
 
     void clearVaImage();
 
diff --git a/src/modules/FFmpeg/VDPAUWriter.hpp b/src/modules/FFmpeg/VDPAUWriter.hpp
index 4c6dc28f..123fb86b 100644
--- a/src/modules/FFmpeg/VDPAUWriter.hpp
+++ b/src/modules/FFmpeg/VDPAUWriter.hpp
@@ -28,27 +28,27 @@
 
 struct _XDisplay;
 
-class VDPAUWriter final : public QWidget, public VideoWriter
+class VDPAUWriter : public QWidget, public VideoWriter
 {
     Q_OBJECT
 public:
     VDPAUWriter(Module &module);
-    ~VDPAUWriter();
+    ~VDPAUWriter() final;
 
-    bool set() override;
+    bool set() override final;
 
-    bool readyWrite() const override;
+    bool readyWrite() const override final;
 
-    bool processParams(bool *paramsCorrected) override;
-    void writeVideo(const VideoFrame &videoFrame) override;
-    void writeOSD(const QList<const QMPlay2OSD *> &osd) override;
-    void pause() override;
+    bool processParams(bool *paramsCorrected) override final;
+    void writeVideo(const VideoFrame &videoFrame) override final;
+    void writeOSD(const QList<const QMPlay2OSD *> &osd) override final;
+    void pause() override final;
 
-    bool hwAccelGetImg(const VideoFrame &videoFrame, void *dest, ImgScaler *nv12ToRGB32) const override;
+    bool hwAccelGetImg(const VideoFrame &videoFrame, void *dest, ImgScaler *nv12ToRGB32) const override final;
 
-    QString name() const override;
+    QString name() const override final;
 
-    bool open() override;
+    bool open() override final;
 
     /**/
 
@@ -78,11 +78,11 @@ private:
     Q_SLOT void draw(VdpVideoSurface surface_id = VDP_INVALID_HANDLE);
     void vdpau_display();
 
-    void resizeEvent(QResizeEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void resizeEvent(QResizeEvent *) override final;
+    void paintEvent(QPaintEvent *) override final;
+    bool event(QEvent *) override final;
 
-    QPaintEngine *paintEngine() const override;
+    QPaintEngine *paintEngine() const override final;
 
     void destroyOutputSurfaces();
     void clr();
diff --git a/src/modules/Inputs/Inputs.hpp b/src/modules/Inputs/Inputs.hpp
index 9cdbcff3..5484fe53 100644
--- a/src/modules/Inputs/Inputs.hpp
+++ b/src/modules/Inputs/Inputs.hpp
@@ -20,18 +20,18 @@
 
 #include <Module.hpp>
 
-class Inputs final : public Module
+class Inputs : public Module
 {
     Q_OBJECT
 public:
     Inputs();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    QList<QAction *> getAddActions() override;
+    QList<QAction *> getAddActions() override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 
     QIcon toneIcon, pcmIcon, rayman2Icon;
 private slots:
@@ -43,7 +43,7 @@ private slots:
 #include <QSpinBox>
 #include <QDialog>
 
-class HzW final : public QWidget
+class HzW : public QWidget
 {
 public:
     HzW(int, const QStringList &);
@@ -60,7 +60,7 @@ private:
 
 class QGridLayout;
 
-class AddD final : public QDialog
+class AddD : public QDialog
 {
     Q_OBJECT
 public:
@@ -95,7 +95,7 @@ class QGroupBox;
 class QCheckBox;
 class QLineEdit;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
 public:
@@ -103,7 +103,7 @@ public:
 private slots:
     void applyFreqs();
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     AddD *toneGenerator;
     QGroupBox *pcmB;
diff --git a/src/modules/Inputs/PCM.hpp b/src/modules/Inputs/PCM.hpp
index eb47a911..528cb35a 100644
--- a/src/modules/Inputs/PCM.hpp
+++ b/src/modules/Inputs/PCM.hpp
@@ -24,25 +24,25 @@
 
 class Reader;
 
-class PCM final : public Demuxer
+class PCM : public Demuxer
 {
 public:
     enum FORMAT {PCM_U8, PCM_S8, PCM_S16, PCM_S24, PCM_S32, PCM_FLT, FORMAT_COUNT};
 
     PCM(Module &);
 private:
-    bool set() override;
+    bool set() override final;
 
-    QString name() const override;
-    QString title() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const override final;
+    QString title() const override final;
+    double length() const override final;
+    int bitrate() const override final;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool) override final;
+    bool read(Packet &, int &) override final;
+    void abort() override final;
 
-    bool open(const QString &) override;
+    bool open(const QString &) override final;
 
     /**/
 
diff --git a/src/modules/Inputs/Rayman2.hpp b/src/modules/Inputs/Rayman2.hpp
index af623d90..2326a272 100644
--- a/src/modules/Inputs/Rayman2.hpp
+++ b/src/modules/Inputs/Rayman2.hpp
@@ -24,23 +24,23 @@
 
 class Reader;
 
-class Rayman2 final : public Demuxer
+class Rayman2 : public Demuxer
 {
 public:
     Rayman2(Module &);
 private:
-    bool set() override;
+    bool set() override final;
 
-    QString name() const override;
-    QString title() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const override final;
+    QString title() const override final;
+    double length() const override final;
+    int bitrate() const override final;
 
-    bool seek(double pos, bool backward) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double pos, bool backward) override final;
+    bool read(Packet &, int &) override final;
+    void abort() override final;
 
-    bool open(const QString &) override;
+    bool open(const QString &) override final;
 
     /**/
 
diff --git a/src/modules/Inputs/ToneGenerator.cpp b/src/modules/Inputs/ToneGenerator.cpp
index 62ff4436..83c1d0ea 100644
--- a/src/modules/Inputs/ToneGenerator.cpp
+++ b/src/modules/Inputs/ToneGenerator.cpp
@@ -21,7 +21,8 @@
 #include <Functions.hpp>
 #include <Packet.hpp>
 
-#include <QUrlQuery>
+#include <QUrl>
+#define QUrlQuery(url) url
 
 #include <cmath>
 
diff --git a/src/modules/Inputs/ToneGenerator.hpp b/src/modules/Inputs/ToneGenerator.hpp
index a84c7fb0..9b29313b 100644
--- a/src/modules/Inputs/ToneGenerator.hpp
+++ b/src/modules/Inputs/ToneGenerator.hpp
@@ -20,28 +20,28 @@
 
 #include <Demuxer.hpp>
 
-class ToneGenerator final : public Demuxer
+class ToneGenerator : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(ToneGenerator)
 public:
     ToneGenerator(Module &);
 
-    bool set() override;
+    bool set() override final;
 private:
-    bool metadataChanged() const override;
+    bool metadataChanged() const override final;
 
-    QString name() const override;
-    QString title() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const override final;
+    QString title() const override final;
+    double length() const override final;
+    int bitrate() const override final;
 
-    bool dontUseBuffer() const override;
+    bool dontUseBuffer() const override final;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool) override final;
+    bool read(Packet &, int &) override final;
+    void abort() override final;
 
-    bool open(const QString &) override;
+    bool open(const QString &) override final;
 
     /**/
 
diff --git a/src/modules/OpenGL2/CMakeLists.txt b/src/modules/OpenGL2/CMakeLists.txt
index 9a411b44..84926476 100644
--- a/src/modules/OpenGL2/CMakeLists.txt
+++ b/src/modules/OpenGL2/CMakeLists.txt
@@ -5,7 +5,6 @@ set(OpenGL2_HDR
     OpenGL2.hpp
     OpenGL2Writer.hpp
     OpenGL2Common.hpp
-    OpenGL2Window.hpp
     OpenGL2Widget.hpp
     Sphere.hpp
     Vertices.hpp
@@ -15,7 +14,6 @@ set(OpenGL2_SRC
     OpenGL2.cpp
     OpenGL2Writer.cpp
     OpenGL2Common.cpp
-    OpenGL2Window.cpp
     OpenGL2Widget.cpp
     Sphere.cpp
 )
@@ -24,15 +22,25 @@ set(OpenGL2_RESOURCES
     res.qrc
 )
 
-if(NOT WIN32)
-    if(Qt5Gui_OPENGL_IMPLEMENTATION STREQUAL GLESv2)
-        set(QT_USES_OPENGLES ON)
-        add_definitions(-DOPENGL_ES2)
-    elseif(Qt5Gui_OPENGL_IMPLEMENTATION STREQUAL GLES)
-        message(SEND_ERROR "OpenGL|ES 1.0 is not supported!")
-    endif()
+function(gles1Error)
+    message(SEND_ERROR "OpenGL|ES 1.0 is not supported!")
+endfunction()
+
+find_package(Qt4 REQUIRED QtOpenGL)
+include(${QT_USE_FILE})
+if(${QT_QCONFIG} MATCHES "opengles2")
+    set(QT_USES_OPENGLES ON)
+    add_definitions(-DOPENGL_ES2)
+elseif(${QT_QCONFIG} MATCHES "opengles1")
+    gles1Error()
 endif()
 
+if(NOT QT_USES_OPENGLES)
+    add_definitions(-DVSYNC_SETTINGS)
+endif()
+
+qt4_add_resources(OpenGL2_RESOURCES_RCC ${OpenGL2_RESOURCES})
+
 include_directories(../../qmplay2/headers)
 
 add_library(${PROJECT_NAME} ${QMPLAY2_MODULE}
@@ -41,6 +49,8 @@ add_library(${PROJECT_NAME} ${QMPLAY2_MODULE}
     ${OpenGL2_RESOURCES}
 )
 
+target_link_libraries(${PROJECT_NAME} Qt4::QtCore Qt4::QtGui Qt4::QtOpenGL)
+
 target_link_libraries(${PROJECT_NAME}
     libqmplay2
 )
@@ -48,12 +58,6 @@ target_link_libraries(${PROJECT_NAME}
 if(APPLE)
     find_package(OpenGL REQUIRED)
     target_link_libraries(${PROJECT_NAME} ${OPENGL_LIBRARIES})
-elseif(WIN32)
-    if(QT_USES_OPENGLES)
-        target_link_libraries(${PROJECT_NAME} GLESv2)
-    else()
-        target_link_libraries(${PROJECT_NAME} opengl32)
-    endif()
 endif()
 
 install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})
